menu .right -tearoff 0
menu .right.if -tearoff 0
	.right.if add command -label "IF" \
		-command {
			.lf.tx configure -state normal
			set newid [p_getnextid]
			.lf.tx insert [p_gettag $CURPOS].last "${tab_str}IF\n$tab_str" "id$newid if all"
			set newid2 [p_getnextid]
			.lf.tx insert id$newid.last "\n$tab_str\{\n" "id$newid2 sblock all"
			set newid [p_getnextid]
			.lf.tx insert id$newid2.last "$tab_str\}\n\n" "id$newid eblock all"
			.lf.tx see id$newid.first
			.lf.tx configure -state disabled
		}
	.right.if add command -label "IF_CONTINUE" \
		-command {
			.lf.tx configure -state normal
			set newid [p_getnextid]
			.lf.tx insert [p_gettag $CURPOS].last "${tab_str}IF_CONTINUE\n$tab_str" "id$newid if all"
			set newid2 [p_getnextid]
			.lf.tx insert id$newid.last "\n$tab_str\{\n" "id$newid2 sblock all"
			set newid [p_getnextid]
			.lf.tx insert id$newid2.last "$tab_str\}\n\n" "id$newid eblock all"
			.lf.tx see id$newid.first
			.lf.tx configure -state disabled
		}
	.right.if add command -label "FILTER" \
		-command {
			.lf.tx configure -state normal
			set newid [p_getnextid]
			.lf.tx insert [p_gettag $CURPOS].last "${tab_str}FILTER\n$tab_str" "id$newid if all"
			set newid2 [p_getnextid]
			.lf.tx insert id$newid.last "\n$tab_str\{\n" "id$newid2 sblock all"
			set newid [p_getnextid]
			.lf.tx insert id$newid2.last "$tab_str\}\n\n" "id$newid eblock all"
			.lf.tx see id$newid.first
			.lf.tx configure -state disabled
		}
	.right.if add command -label "ELSEIF_NOEXEC" \
		-command {
			.lf.tx configure -state normal
			set newid [p_getnextid]
			.lf.tx insert [p_gettag $CURPOS].last "${tab_str}ELSEIF_NOEXEC\n$tab_str" "id$newid if all"
			set newid2 [p_getnextid]
			.lf.tx insert id$newid.last "\n$tab_str\{\n" "id$newid2 sblock all"
			set newid [p_getnextid]
			.lf.tx insert id$newid2.last "$tab_str\}\n\n" "id$newid eblock all"
			.lf.tx see id$newid.first
			.lf.tx configure -state disabled
		}
	.right.if add command -label "ELSEIF_ERROR" \
		-command {
			.lf.tx configure -state normal
			set newid [p_getnextid]
			.lf.tx insert [p_gettag $CURPOS].last "${tab_str}ELSEIF_ERROR\n$tab_str" "id$newid if all"
			set newid2 [p_getnextid]
			.lf.tx insert id$newid.last "\n$tab_str\{\n" "id$newid2 sblock all"
			set newid [p_getnextid]
			.lf.tx insert id$newid2.last "$tab_str\}\n\n" "id$newid eblock all"
			.lf.tx see id$newid.first
			.lf.tx configure -state disabled
		}

set IF(none) ""
set IF(0) "If, execute and stop"
set IF(1) "If, execute and continue with a copy of the mail"
set IF(2) "Conditional filter, execute and continue with the filtered mail"
set IF(3) "Else if the last recipe did not execute"
set IF(4) "Else if last recipe failed"

bind .right.if <Motion> {
	.mb.f.lb configure -text $IF([.right.if index active])
}

bind .right.if <Any-Leave> {
	.mb.f.lb configure -text ""
}

menu .right.andcond -tearoff 0
	.right.andcond add command -label "TRUE" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "TRUE"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "TRUE"
				p_addafter "and" "\n${tab_str}AND "
			}\
			else\
			{
				p_addafter "and" "\n${tab_str}AND "
				p_addafter "cond" "TRUE"
			}
		}
	.right.andcond add command -label "FALSE" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "FALSE"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "FALSE"
				p_addafter "and" "\n${tab_str}AND "
			}\
			else\
			{
				p_addafter "and" "\n${tab_str}AND "
				p_addafter "cond" "FALSE"
			}
		}
	.right.andcond add separator
	.right.andcond add command -label "HEADER" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Header contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "HEADER $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "HEADER $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "HEADER $asked"
				}
			}
		}
	.right.andcond add command -label "BODY" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Body contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "BODY $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "BODY $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "BODY $asked"
				}
			}
		}
	.right.andcond add separator
	.right.andcond add command -label "SUBJECT" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Subject contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "SUBJECT $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "SUBJECT $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "SUBJECT $asked"
				}
			}
		}
	.right.andcond add command -label "TO" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "To contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "TO $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "TO $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "TO $asked"
				}
			}
		}
	.right.andcond add command -label "FROM" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "From contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "FROM $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "FROM $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "FROM $asked"
				}
			}
		}
	.right.andcond add command -label "X_LOOP" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Your email address: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "X_Loop $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "X_Loop $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "X_Loop $asked"
				}
			}
		}
	.right.andcond add separator
	.right.andcond add command -label "FROM_DAEMON" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "FROM_DAEMON"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "FROM_DAEMON"
				p_addafter "and" "\n${tab_str}AND "
			}\
			else\
			{
				p_addafter "and" "\n${tab_str}AND "
				p_addafter "cond" "FROM_DAEMON"
			}
		}
	.right.andcond add command -label "FROM_MAILER" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "FROM_MAILER"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "FROM_MAILER"
				p_addafter "and" "\n${tab_str}AND "
			}\
			else\
			{
				p_addafter "and" "\n${tab_str}AND "
				p_addafter "cond" "FROM_MAILER"
			}
		}
	.right.andcond add separator
	.right.andcond add command -label ">" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Length > " "" "bytes"
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "> $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "> $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "> $asked"
				}
			}
		}
	.right.andcond add command -label "<" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Length < " "" "bytes"
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "< $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "< $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "< $asked"
				}
			}
		}
	.right.andcond add separator
	.right.andcond add command -label "EMPTY" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Variable name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "EMPTY $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "EMPTY $asked"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "EMPTY $asked"
				}
			}
		}
	.right.andcond add command -label "VAR_MATCH" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Variable name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				set v $asked
				p_ask asked "Match: "
				tkwait variable asked
				set asked [p_removespace "$asked"]
				if {$asked != "CANCEL"}\
				{
					if {$curtype == "if" && $nexttype == "sblock"}\
					{
						p_addafter "cond" "VAR_MATCH $v $asked"
					}\
					elseif {$curtype == "if"}\
					{
						p_addafter "cond" "VAR_MATCH $v $asked"
						p_addafter "and" "\n${tab_str}AND "
					}\
					else\
					{
						p_addafter "and" "\n${tab_str}AND "
						p_addafter "cond" "VAR_MATCH $v $asked"
					}
				}
			}
		}
	.right.andcond add separator
	.right.andcond add command -label "EXIT_CODE" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				regsub -all {\(} $asked {\(} asked
				regsub -all {\)} $asked {\)} asked
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "EXIT_CODE ( $asked )"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "EXIT_CODE ( $asked )"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "EXIT_CODE ( $asked )"
				}
			}
		}
	.right.andcond add command -label "CUST_COND" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Custom condition: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				regsub -all {\(} $asked {\(} asked
				regsub -all {\)} $asked {\)} asked
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "CUST_COND ( $asked )"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "CUST_COND ( $asked )"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "CUST_COND ( $asked )"
				}
			}
		}

set COND(none) ""
set COND(0) "Always true condition"
set COND(1) "Always false condition"
set COND(3) "Header contains"
set COND(4) "Body contains"
set COND(6) "Subject contains"
set COND(7) "To contains"
set COND(8) "From contains"
set COND(9) "X-Loop contains"
set COND(11) "FROM_DAEMON"
set COND(12) "FROM_MAILER"
set COND(14) "Length superior to"
set COND(15) "Length inferior to"
set COND(17) "Variable empty"
set COND(18) "Variable match"
set COND(20) "Exit code of a program"
set COND(21) "Custom condition"

bind .right.andcond <Motion> {
	.mb.f.lb configure -text $COND([.right.andcond index active])
}

bind .right.andcond <Any-Leave> {
	.mb.f.lb configure -text ""
}

menu .right.orcond -tearoff 0
	.right.orcond add command -label "TRUE" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "TRUE"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "TRUE"
				p_addafter "or" "\n${tab_str}OR "
			}\
			else\
			{
				p_addafter "or" "\n${tab_str}OR "
				p_addafter "cond" "TRUE"
			}
		}
	.right.orcond add command -label "FALSE" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "FALSE"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "FALSE"
				p_addafter "or" "\n${tab_str}OR "
			}\
			else\
			{
				p_addafter "or" "\n${tab_str}OR "
				p_addafter "cond" "FALSE"
			}
		}
	.right.orcond add separator
	.right.orcond add command -label "HEADER" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Header contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "HEADER $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "HEADER $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "HEADER $asked"
				}
			}
		}
	.right.orcond add command -label "BODY" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Body contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "BODY $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "BODY $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "BODY $asked"
				}
			}
		}
	.right.orcond add separator
	.right.orcond add command -label "SUBJECT" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Subject contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "SUBJECT $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "SUBJECT $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "SUBJECT $asked"
				}
			}
		}
	.right.orcond add command -label "TO" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "To contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "TO $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "TO $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "TO $asked"
				}
			}
		}
	.right.orcond add command -label "FROM" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "From contains: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "FROM $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "FROM $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "FROM $asked"
				}
			}
		}
	.right.orcond add command -label "X_LOOP" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Your email address: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "X_Loop $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "X_Loop $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "X_Loop $asked"
				}
			}
		}
	.right.orcond add separator
	.right.orcond add command -label "FROM_DAEMON" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "FROM_DAEMON"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "FROM_DAEMON"
				p_addafter "or" "\n${tab_str}OR "
			}\
			else\
			{
				p_addafter "or" "\n${tab_str}OR "
				p_addafter "cond" "FROM_DAEMON"
			}
		}
	.right.orcond add command -label "FROM_MAILER" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			if {$curtype == "if" && $nexttype == "sblock"}\
			{
				p_addafter "cond" "FROM_MAILER"
			}\
			elseif {$curtype == "if"}\
			{
				p_addafter "cond" "FROM_MAILER"
				p_addafter "or" "\n${tab_str}OR "
			}\
			else\
			{
				p_addafter "or" "\n${tab_str}OR "
				p_addafter "cond" "FROM_MAILER"
			}
		}
	.right.orcond add separator
	.right.orcond add command -label ">" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Length > " "" "bytes"
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "> $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "> $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "> $asked"
				}
			}
		}
	.right.orcond add command -label "<" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Length < " "" "bytes"
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "< $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "< $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "< $asked"
				}
			}
		}
	.right.orcond add separator
	.right.orcond add command -label "EMPTY" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Variable name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "EMPTY $asked"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "EMPTY $asked"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "EMPTY $asked"
				}
			}
		}
	.right.orcond add command -label "VAR_MATCH" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Variable name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				set v $asked
				p_ask asked "Match: "
				tkwait variable asked
				set asked [p_removespace "$asked"]
				if {$asked != "CANCEL"}\
				{
					if {$curtype == "if" && $nexttype == "sblock"}\
					{
						p_addafter "cond" "VAR_MATCH $v $asked"
					}\
					elseif {$curtype == "if"}\
					{
						p_addafter "cond" "VAR_MATCH $v $asked"
						p_addafter "or" "\n${tab_str}"
					}\
					else\
					{
						p_addafter "or" "\n${tab_str}"
						p_addafter "cond" "VAR_MATCH $v $asked"
					}
				}
			}
		}
	.right.orcond add separator
	.right.orcond add command -label "EXIT_CODE" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				regsub -all {\(} $asked {\(} asked
				regsub -all {\)} $asked {\)} asked
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "EXIT_CODE ( $asked )"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "EXIT_CODE ( $asked )"
					p_addafter "and" "\n${tab_str}AND "
				}\
				else\
				{
					p_addafter "and" "\n${tab_str}AND "
					p_addafter "cond" "EXIT_CODE ( $asked )"
				}
			}
		}
	.right.orcond add command -label "CUST_COND" \
		-command \
		{
			set curtype [p_gettype $CURPOS]
			set nexttype [p_gettype [p_gettag $CURPOS].last+1c]
			p_ask asked "Custom condition: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				regsub -all {\(} $asked {\(} asked
				regsub -all {\)} $asked {\)} asked
				if {$curtype == "if" && $nexttype == "sblock"}\
				{
					p_addafter "cond" "CUST_COND ( $asked )"
				}\
				elseif {$curtype == "if"}\
				{
					p_addafter "cond" "CUST_COND ( $asked )"
					p_addafter "or" "\n${tab_str}OR "
				}\
				else\
				{
					p_addafter "or" "\n${tab_str}OR "
					p_addafter "cond" "CUST_COND ( $asked )"
				}
			}
		}

bind .right.orcond <Motion> {
	.mb.f.lb configure -text $COND([.right.orcond index active])
}

bind .right.orcond <Any-Leave> {
	.mb.f.lb configure -text ""
}

menu .right.act -tearoff 0
	.right.act add command -label "MAIL" -command \
		{
			p_ask asked "Mail to: "
			tkwait variable asked
			regsub -all { } $asked {,} asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}MAIL $asked\n"
			}
		}
	.right.act add separator
	.right.act add command -label "MAILBOX" -command \
		{
			p_ask asked "Send to mailbox: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}MAILBOX $asked\n"
			}
		}
	.right.act add separator
	.right.act add command -label "h_PROGRAM" -command \
		{
			p_ask asked "Send header to program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}h_PROGRAM $asked\n"
			}
		}
	.right.act add command -label "b_PROGRAM" -command \
		{
			p_ask asked "Send body to program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}b_PROGRAM $asked\n"
			}
		}
	.right.act add command -label "hb_PROGRAM" -command \
		{
			p_ask asked "Send header and body to program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}hb_PROGRAM $asked\n"
			}
		}
	.right.act add separator
	.right.act add command -label "h_REMOVE" -command \
		{
			p_ask asked "Field to remove: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {[cindex $asked end] != ":"}\
				{
					append asked ":"
				}
				p_addafter "act" "${tab_str}h_REMOVE $asked\n"
			}
		}
	.right.act add command -label "h_SET" -command \
		{
			p_ask asked "Field name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {[cindex $asked end] != ":"}\
				{
					append asked ":"
				}
				set f $asked
				p_ask asked "Value: "
				tkwait variable asked
				if {$asked != "CANCEL"}\
				{
					p_addafter "act" "${tab_str}h_SET $f $asked\n"
				}
			}
		}
	.right.act add command -label "h_ADD" -command \
		{
			p_ask asked "Field name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				if {[cindex $asked end] != ":"}\
				{
					append asked ":"
				}
				set f $asked
				p_ask asked "Value: "
				tkwait variable asked
				if {$asked != "CANCEL"}\
				{
					p_addafter "act" "${tab_str}h_ADD $f $asked\n"
				}
			}
		}
	.right.act add separator
	.right.act add command -label "h_FILTER" -command \
		{
			p_ask asked "Filter program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}h_FILTER $asked\n"
			}
		}
	.right.act add command -label "b_FILTER" -command \
		{
			p_ask asked "Filter program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}b_FILTER $asked\n"
			}
		}
	.right.act add command -label "hb_FILTER" -command \
		{
			p_ask asked "Filter program: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "act" "${tab_str}hb_FILTER $asked\n"
			}
		}
	.right.act add separator
	.right.act add command -label "DELETE" -command \
		{
			p_addafter "act" "${tab_str}DELETE\n"
		}

set ACT(none) ""
set ACT(0) "Forward the mail"
set ACT(2) "Deliver to a mailbox"
set ACT(4) "Send the header to a program"
set ACT(5) "Send the body to a program"
set ACT(6) "Send the whole mail to a program"
set ACT(8) "Remove a field from the header"
set ACT(9) "Set the value of a field in the header"
set ACT(10) "Add a field in the header"
set ACT(12) "Filter the header"
set ACT(13) "Filter the body"
set ACT(14) "Filter the whole mail"
set ACT(16) "Delete the mail"

bind .right.act <Motion> {
	.mb.f.lb configure -text $ACT([.right.act index active])
}

bind .right.act <Any-Leave> {
	.mb.f.lb configure -text ""
}

menu .right.globvar -tearoff 0
	.right.globvar add command -label "Set variable" \
		-command {
			p_ask asked "Variable name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				set vn $asked
				p_ask asked "Value: "
				tkwait variable asked
				if {$asked != "CANCEL"}\
				{
					p_addafter "glob" "${tab_str}SET_VAR $vn $asked\n"
				}
			}
		}
	.right.globvar add command -label "Unset variable" \
		-command {
			p_ask asked "Variable name: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				p_addafter "glob" "${tab_str}UNSET $asked\n"
			}
		}
	.right.globvar add separator
	.right.globvar add command -label "MAILDIR" \
		-command {
			p_ask asked "Mail directory: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				p_addafter "glob" "${tab_str}MAILDIR $asked\n"
			}
		}

menu .right.globlog -tearoff 0
	.right.globlog add command -label "LOGFILE" \
		-command {
			p_ask asked "Log file: "
			tkwait variable asked
			set asked [p_removespace "$asked"]
			if {$asked != "CANCEL"}\
			{
				p_addafter "glob" "${tab_str}LOGFILE $asked\n"
			}
		}
	.right.globlog add command -label "Add a line to LOGFILE" \
		-command {
			p_ask asked "Line to add: "
			tkwait variable asked
			if {$asked != "CANCEL"}\
			{
				p_addafter "glob" "${tab_str}LOG $asked\n"
			}
		}
	.right.globlog add command -label "Log abstract for delivered mail" \
		-command {p_addafter "glob" "${tab_str}LOGABSTRACT\n"}
	.right.globlog add command -label "Don't log abstract" \
		-command {p_addafter "glob" "${tab_str}NO_LOGABSTRACT\n"}
	.right.globlog add command -label "Verbose, extended diagnostic" \
		-command {p_addafter "glob" "${tab_str}VERBOSE\n"}
	.right.globlog add command -label "Don't be verbose" \
		-command {p_addafter "glob" "${tab_str}NO_VERBOSE\n"}

